import msvcrt
import time
import sys
from os import system
from random import randint, choice
from table_of_record import TableOfRecords


class Game():
    def __init__(self) -> None:
        self.game_run = True
        self.tableofrecord = TableOfRecords(filename='records.txt')
        self.field, self.cars = [], []
        self.rows = 10
        self.cols = 5
        self.time_obstacles = 2

    def creating_a_field(self) -> None:
        """создание поля"""
        for _ in range(self.rows):
            row = [0] * self.cols
            self.field.append(row)
        for y in range(self.rows):
            for x in range(self.cols):
                cell = Cell(x+1, y+1)
                self.field[y][x] = cell
    
    def timed_input(self, caption, timeout=0.4):
            def echo(c):
                sys.stdout.write(c)
                sys.stdout.flush()        
            echo(caption)
            _input = []
            start = time.monotonic()
            while time.monotonic() - start < timeout:
                if msvcrt.kbhit():
                    c = msvcrt.getwch()
                    if ord(c) == 13:
                        echo('\r\n')
                        break
                    _input.append(c)
                    echo(c)
            if _input:
                return ''.join(_input)

    def move_car(self):
        v = self.timed_input('')
        if v == 'a' or v == 'ф':
            self.player.x -= 1
        elif v == 'd' or v == 'в':
            self.player.x += 1
        if self.player.x == 1 or self.player.x == 5:
            self.game_run = False
            return
        
        for car in self.cars:
            if car.y == 9 and car.x == self.player.x:
                self.game_run = False
                return
            if car.y == 11:
                self.cars.remove(car)
                self.player_score += 1
            else:
                car.y = car.y + 1

    def creating_obstacles(self):
        if self.time_obstacles == 0:
            if randint(1,2) == 1:
                car = Car(randint(2,4), 1)
                self.cars.append(car)
            else:
                cords_list = [2, 3, 4]
                for _ in range(2):
                    cord = choice(cords_list)
                    cords_list.remove(cord)
                    car = Car(cord, 1)
                    self.cars.append(car)
            self.time_obstacles = randint(2, 6)
        else:
            self.time_obstacles -= 1

    def show_field(self):
        for row in self.field:
            for col in row:
                col.uppdate_content(self.cars, self.player)
                print(col.content, end='  ')
            print()
        print(f"всего набранно очков {self.player_score}")

    def start(self):
        self.player_score = 0
        self.creating_a_field()
        self.player = Car(3, 10, True)
        while self.game_run:
            system("cls")
            self.show_field()
            self.move_car()
            self.creating_obstacles()
        print()
        system("cls")
        self.show_field()
        input("Вы врезались")
        if self.tableofrecord.compare_records(self.player_score):
            system('cls')
            print("Вау у вас новый рекорд! это нужно запомнить")
            print("запишите новый рекорд в таблицу рекордов")
            time.sleep(2)
            record_name = input("Впишите имя рекорда: ")
            record = {'name': record_name, 'points': self.player_score}
            self.tableofrecord.add_record(record)
            self.tableofrecord.sorted_scores()
            self.tableofrecord.write_records_to_file()


class Cell():
    def __init__(self, x, y) -> None:
        self.x = x
        self.y = y
        self.img = "|"
        self.is_barrier = False
    
    def uppdate_content(self, cars, player):
        self.content = None
        if self.x == 1:
            self.content = "]"
        if self.x == 5:
            self.content = "["
        for car in cars:
            if self.x == car.x and self.y == car.y:
                self.content = car.img
        if self.x == player.x and self.y == 10:
            self.content = player.img
        if self.content == None:
            self.content = self.img


class Car():
    def __init__(self, x, y, is_player=False) -> None:
        self.is_player = is_player
        self.img = "⤋"
        if self.is_player:
            self.img = "⤊"
        self.x = x
        self.y = y

game = Game()
game.start()
game.tableofrecord.show_scores()